subroutine v2f(Vd,Vv,Vp,Ub,Fd,Fm,Fe,Fb,ix,is,ie)
  implicit none
  real(8) :: Vd(ix), Vv(ix,3), Vp(ix)  ! primitive variables (V) [input]
  real(8) :: Ub(ix,3)                  ! magnetic field (U) [input]
  real(8) :: Fd(ix), Fm(ix,3), Fe(ix), Fb(ix,3) ! numerical flux (F) [output]
  integer :: ix, is, ie
  integer :: i
  real(8) :: v2, u02, u0, W, B2, vB
  
  do i=is,ie

     v2 = dot_product( Vv(i,1:3), Vv(i,1:3) )
     u02 = 1.d0 / ( 1.d0 - v2 )
     u0  = sqrt( u02 )
     W   = u02 * ( Vd(i) + 4.d0 * Vp(i) )
     vB = dot_product( Ub(i,1:3), Vv(i,1:3) )
     B2 = dot_product( Ub(i,1:3), Ub(i,1:3) )
     
     Fd(i)   = u0 * Vd(i) * Vv(i,1)
     Fm(i,1) = (W+B2) * Vv(i,1)*Vv(i,1) + Vp(i) &
          - 2*vB*( Ub(i,1)*Vv(i,1) ) &
          + 0.5d0*( B2*(1.d0-v2) + vB**2 )
     Fm(i,2) = (W+B2) * Vv(i,1)*Vv(i,2) - (1-v2)*Ub(i,1)*Ub(i,2) &
          - vB*( Ub(i,1)*Vv(i,2)+Ub(i,2)*Vv(i,1) )
     Fm(i,3) = (W+B2) * Vv(i,1)*Vv(i,3) - (1-v2)*Ub(i,1)*Ub(i,3) &
          - vB*( Ub(i,1)*Vv(i,3)+Ub(i,3)*Vv(i,1) )
     Fe(i)   = (W+B2) * Vv(i,1) - vB * Ub(i,1)
     Fb(i,1) = 0.d0
     Fb(i,2) = Vv(i,1)*Ub(i,2)-Ub(i,1)*Vv(i,2)
     Fb(i,3) = Vv(i,1)*Ub(i,3)-Ub(i,1)*Vv(i,3)
     
  enddo

  return
end subroutine v2f
