subroutine v2u(Vd,Vv,Vp,Ub,Ud,Um,Ue,ix,is,ie)
  implicit none
  real(8) :: Vd(ix), Vv(ix,3), Vp(ix)  ! primitive variables (V) [input]
  real(8) :: Ub(ix,3)                  ! magnetic field (U) [input]
  real(8) :: Ud(ix), Um(ix,3), Ue(ix)  ! conserved variables (U) [output]
  integer :: ix, is, ie
  integer :: i
  real(8) :: v2, u02, u0, W, B2, vB

  do i=is,ie
     
     v2 = dot_product( Vv(i,1:3), Vv(i,1:3) )
     u02= 1.d0 / ( 1.d0 - v2 )
     u0 = sqrt( u02 )
     W  = u02 * ( Vd(i) + 4.d0 * Vp(i) )
     vB = dot_product( Ub(i,1:3), Vv(i,1:3) )
     B2 = dot_product( Ub(i,1:3), Ub(i,1:3) )
     
     Ud(i)   = u0 * Vd(i)
     Um(i,1:3) = (W+B2) * Vv(i,1:3) - vB * Ub(i,1:3)
     Ue(i)   = W - Vp(i) + 0.5d0*( (1.d0+v2)*B2 - vB**2 )

  enddo

  return
end subroutine v2u
